/*! Built with http://stenciljs.com */
import { h } from './bscomponents.core.js';
import { a as _size } from './chunk-10f3ce4f.js';
import { d as _get } from './chunk-def07e68.js';
import { a as closest } from './chunk-b81252fc.js';
import { a as elementMatches } from './chunk-e18b632f.js';
import { l as hasClass, m as addClass, n as removeClass, o as customEvent } from './chunk-1adf00f9.js';
// http://youmightnotneedjquery.com/
function toggleClass(el, className) {
    if (el.classList) {
        el.classList.toggle(className);
    }
    else {
        var classes = el.className.split(' ');
        var existingIndex = classes.indexOf(className);
        if (existingIndex >= 0)
            classes.splice(existingIndex, 1);
        else
            classes.push(className);
        el.className = classes.join(' ');
    }
}
var BsButton = /** @class */ (function () {
    function BsButton() {
    }
    BsButton.prototype.componentDidLoad = function () {
        var currentTabIndex = this.bsButtonEl.getAttribute('tabindex');
        var buttonToggleData = _get(this.bsButtonEl, 'dataset.toggle', '');
        if (_size(currentTabIndex) === 0 && buttonToggleData === 'button') {
            // without tabindex set the bs-button can not receive focus
            this.bsButtonEl.setAttribute('tabindex', '0');
        }
    };
    // componentDidUnload() {
    //   document.removeEventListener('click', this.removeFocusFromBsButtonEl);
    // }
    // addFocusToBsButtonEl = () => {
    //   addClass(this.bsButtonEl, 'focus');
    //   document.addEventListener('click', this.removeFocusFromBsButtonEl, { once: true });
    //   (document.activeElement as any).blur();
    // }
    // removeFocusFromBsButtonEl = () => {
    //   document.removeEventListener('click', this.removeFocusFromBsButtonEl);
    //   removeClass(this.bsButtonEl, 'focus');
    // }
    BsButton.prototype.handleFocusIn = function (event) {
        var buttonToggleData = _get(this.bsButtonEl, 'dataset.toggle', '');
        if (buttonToggleData === 'button') {
            // focus is handled by the tabindex attribute
            var isDisabled = hasClass(this.bsButtonEl, 'disabled');
            if (isDisabled) {
                // put the focus back where it was
                if (event.relatedTarget) {
                    event.relatedTarget.focus();
                }
                else {
                    document.activeElement.blur();
                }
                event.preventDefault();
                return;
            }
            // TODO: add listeners to keydown space and keydown enter to click to toggle
            return;
        }
        var closestButton = this.getClosestButtonInsideComponent(event.target);
        addClass(closestButton, 'focus');
    };
    BsButton.prototype.handleFocusOut = function (event) {
        var buttonToggleData = _get(this.bsButtonEl, 'dataset.toggle', '');
        if (buttonToggleData === 'button') {
            // focus is handled by the tabindex attribute
            // TODO: remove the listeners to keydown space and keydown enter
            return;
        }
        var closestButton = this.getClosestButtonInsideComponent(event.target);
        removeClass(closestButton, 'focus');
    };
    BsButton.prototype.handleButtonClick = function (event) {
        var hasBtnClass = hasClass(event.target, 'btn');
        if (!hasBtnClass) {
            return;
        }
        var isDisabled = hasClass(this.bsButtonEl, 'disabled');
        if (isDisabled) {
            return;
        }
        var buttonToggleData = _get(event, 'target.dataset.toggle', '');
        this.handleToggle(event.target);
        if (buttonToggleData === 'modal') {
            var modalTargetSelector = _get(event, 'target.dataset.target', '');
            if (_size(modalTargetSelector) > 0) {
                var modalTarget = document.querySelector(modalTargetSelector);
                if (modalTarget.modalToggleButtonClicked) {
                    modalTarget.modalToggleButtonClicked(event.target);
                }
            }
        }
    };
    BsButton.prototype.getClosestButtonInsideComponent = function (element) {
        var currentEl = element.parentElement || element.parentNode;
        while (currentEl !== null && currentEl.nodeType === 1) {
            if (elementMatches(currentEl, '.btn')) {
                return currentEl;
            }
            if (this.bsButtonEl.isEqualNode(currentEl)) {
                return null;
            }
            currentEl = element.parentElement || element.parentNode;
        }
        return null;
    };
    BsButton.prototype.handleToggle = function (element) {
        var rootElement = closest(element, '[data-toggle="buttons"]');
        var triggerChangeEvent = true;
        var addAriaPressed = true;
        if (rootElement) {
            var input = element.querySelector('input');
            if (input) {
                if (input.type === 'radio') {
                    if (input.checked && hasClass(element, 'active')) {
                        triggerChangeEvent = false;
                    }
                    else {
                        var activeElement = rootElement.querySelector('.active');
                        if (activeElement) {
                            removeClass(activeElement, 'active');
                        }
                    }
                }
                if (triggerChangeEvent) {
                    if (input.hasAttribute('disabled') || rootElement.hasAttribute('disabled') || hasClass(input, 'disabled') || hasClass(rootElement, 'disabled')) {
                        return;
                    }
                    input.checked = !hasClass(element, 'active');
                    customEvent(input, 'change');
                }
                input.focus();
                addAriaPressed = false;
            }
        }
        else {
            // (this.bsButtonEl as any).tabStop = true;
            // this.bsButtonEl.setAttribute('tabindex', '0');
            var buttonToggleData = _get(this.bsButtonEl, 'dataset.toggle', '');
            if (buttonToggleData !== 'button') {
                triggerChangeEvent = false;
            }
            // setTimeout(() => {
            //   this.addFocusToBsButtonEl();
            // }, 0);
        }
        if (addAriaPressed) {
            element.setAttribute('aria-pressed', !hasClass(element, 'active'));
        }
        if (triggerChangeEvent) {
            toggleClass(element, 'active');
        }
    };
    // @Method()
    // removeFocus() {
    //   document.removeEventListener('click', this.removeFocusFromBsButtonEl);
    // }
    BsButton.prototype.toggle = function (selector) {
        if (_size(selector) === 0) {
            this.handleToggle(this.bsButtonEl);
        }
        else {
            this.handleToggle(this.bsButtonEl.querySelector(selector));
        }
    };
    BsButton.prototype.render = function () {
        return (h("slot", null));
    };
    Object.defineProperty(BsButton, "is", {
        get: function () { return "bs-button"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsButton, "properties", {
        get: function () {
            return {
                "bsButtonEl": {
                    "elementRef": true
                },
                "toggle": {
                    "method": true
                }
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsButton, "listeners", {
        get: function () {
            return [{
                    "name": "focusin",
                    "method": "handleFocusIn"
                }, {
                    "name": "focusout",
                    "method": "handleFocusOut"
                }, {
                    "name": "click",
                    "method": "handleButtonClick"
                }];
        },
        enumerable: true,
        configurable: true
    });
    return BsButton;
}());
export { BsButton };
